% Show the effect of oversampling on the quality measure

legInit;

% for averaging 
num_rands = 100;

mus = [];
for( m = n_leg+1 : 20.0 * (n_leg+1))
  
  cur = 0.0;
  for( a = 1 : num_rands)
  
    % construct sampling points
    lambdas = rand( m, 1);
    lambdas = sort( (2.0 * lambdas) - 1.0)';
    
    % construct corresponding kernel matrix
    K = legKernelMatrix( n_leg, lambdas);
  
    cur = cur + cond(K);
    
  end
    
  mus(end+1) = cur / num_rands;
  
end

%% Visualization

legPreVisualization

plot( [n_leg+1 : n_leg + numel(mus)], mus, '-r');
plot( [n_leg+1 : n_leg + numel(mus)], ones(size(mus)), ...
      'Color', [0.8, 0.8, 0.8]);

legPostVisualization;

xlim( [n_leg+1, n_leg + numel(mus)]);
ylim( [0, max(mus)]);
set( gca, 'YScale', 'log');
set(gca,'YTick',[10^0, 10^1, 10^2, 10^3])

savePlot( h_fig, 'legPlotMuOversampling');