function [f_approx, coeffs_approx, condK] = ...
   legRKApproximate( n_leg, n_leg_approx, lambdas, coeffs, xvals )
%
% f_approx, coeffs_approx, condK] = ...
%   legRKApproximate( n_leg, n_leg_approx, lambdas, coeffs, xvals )
%
% Approximate Legendre polynomial signal using RK basis.


  K = legKernelMatrix( n_leg_approx, lambdas);
  S = pinv(K);
  f_approx.condK = cond(K);

  f_samples = legEvalSignal( n_leg, coeffs, lambdas);
  f_approx.coeffs = transpose( S * f_samples');

  f_approx.vals = legEvalSignal( n_leg_approx, f_approx.coeffs, xvals);
  
end