function fvals = signalCharacteristic( xvals)
%
% fvals = signalCharacteristic( xvals)
%
% Test signal in the space spanned by characteristic functions.
%
% @param xvals  evaluation points for the signal

  % set  up signal
  heights = [ 0.2, 0.3, 0.35, 0.25, 0.1, -0.05, -0.15, -0.2, ...
              -0.25, -0.1, 0.0, 0.2, 0.5, 0.7, 0.6, 0.5, ...
              0.4, 0.35, 0.3, 0.35, 0.375];
  x_lims = [-1.0 : 0.1 : 1.0];

  fvals = zeros( size( xvals));

  % fill in function values
  for( i = 1 : numel(x_lims)-1)
    
    idx0 = find( xvals > x_lims(i));
    idx1 = find( xvals(idx0) <= x_lims(i+1));
    
    fvals(idx0(idx1)) = heights(i);
    
  end

end
