function [f,df] = signal( x_in)
%
% [f,df] = signal( x)
% 
% Test function in [-1,1] (with derivative if necessary / desired)
%
% @param x_in  x values in [0,1]

  f = zeros( size( x_in));
  df = zeros( size( x_in));

  idx = (x_in >= -1.0) & (x_in <= -0.3);
  x = x_in(idx);
  xx = [-1.0 : 0.1 : -0.3];
  yy = [-0.3, -0.1, 0.4, 0.2, 0.0, -0.6, -0.6, -0.1];
  f(idx) = spline( xx, yy, x);
  % derivative
  pp = spline( xx, yy);
  p_der = fnder(pp,1);
  df(idx) = ppval(p_der,x);
  
  idx = (x_in >= -0.3) & (x_in <= 0.17);
  x = x_in(idx);
  xx = [-0.3 : 0.1 : 0.17, 0.17];
  yy = [0.5, 0.2, 0.3, 0.2, 0.4, 1.5];
  f(idx) = spline( xx, yy, x);
  % derivative
  pp = spline( xx, yy);
  p_der = fnder(pp,1);
  df(idx) = ppval(p_der,x);
  
  idx = (x_in >= 0.17) & (x_in <= 0.8);
  x = x_in(idx);
  xx = [0.17, 0.2 : 0.1 : 0.8];
  yy = [1.5, -0.1, -0.3, -0.3, -0.12, 0.05, 0.1, 0.1];
  f(idx) = spline( xx, yy, x);
  % derivative
  pp = spline( xx, yy);
  p_der = fnder(pp,1);
  df(idx) = ppval(p_der,x);
  
  idx = (x_in >= 0.8) & (x_in <= 1.0);
  x = x_in(idx);
  xx = [0.8 : 0.1 : 1.0];
  yy = [0.3, 0.2, -0.1];
  f(idx) = spline( xx, yy, x);
  % derivative
  pp = spline( xx, yy);
  p_der = fnder(pp,1);
  df(idx) = ppval(p_der,x);
  
end
